/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;

public class UiErrors implements Serializable {

	private static final long serialVersionUID = 1L;

	public UiErrors() {
	}

	public void addError(String key, UiError error) {
		if (!errors.containsKey(key)) {
			errors.put(key, new ArrayList<UiError>());
		}
		errors.get(key).add(error);
	}

	public ArrayList<UiError> getErrors(String key) {
		return errors.get(key);
	}

	public boolean hasErrors() {
		return !errors.isEmpty();
	}

	public boolean hasErrors(String key) {
		return errors.containsKey(key);
	}

	public void clearErrors() {
		errors.clear();
	}

	public void clearErrors(String key) {
		errors.remove(key);
	}

	private HashMap<String, ArrayList<UiError>> errors = new HashMap<String, ArrayList<UiError>>();

	@SuppressWarnings("unused")
	private ArrayList<UiError> f1 = new ArrayList<UiError>();

}
