/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.widgets;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.DecoratedPopupPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class BDialogBox extends DecoratedPopupPanel {

	private VerticalPanel verticalPanel;

	private SimplePanel simplePanel;

	private LTitle lTitle;

	private BFocusPanel closePanel;

	public BDialogBox() {
		setGlassEnabled(true);
		verticalPanel = new VerticalPanel();
		verticalPanel.setStyleName("BDialogBoxBackground");

		super.setWidget(verticalPanel);

		lTitle = new LTitle();
		verticalPanel.add(lTitle);
		lTitle.setWidgetAlignment(HasHorizontalAlignment.ALIGN_RIGHT);

		closePanel = new BFocusPanel();
		closePanel.setStyleName("BDialogBoxClose");
		closePanel.setWidget(new HTML("&nbsp;"));
		lTitle.add(closePanel);

		closePanel.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				hide();
			}
		});

		simplePanel = new SimplePanel();
		simplePanel.setStyleName("BDialogBoxBody");
		verticalPanel.add(simplePanel);
	}

	public void setWidget(Widget w) {
		simplePanel.setWidget(w);
	}

	public void setTitleKey(String key) {
		lTitle.setKey(key);
	}

}
