package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.Label;
import com.gwtorbit.client.model.UiData;
import com.gwtorbit.client.model.UiDataDisplay;
import com.gwtorbit.client.model.UiErrors;
import com.gwtorbit.client.mvp.ClientResourceBundle;

public class UiLabelBoolean extends Label implements UiDataDisplay {

	public UiLabelBoolean() {

	}

	private String trueLabelKey = "UiLabelBoolean.trueLabel";

	private String falseLabelKey = "UiLabelBoolean.falseLabel";

	public void displayData(UiData uiData) {
		Boolean val = null;
		if (dataName.indexOf(".") > -1) {
			String[] names = dataName.split("\\.");
			for (int i = 0; i < (names.length - 1); i++) {
				uiData = (UiData) uiData.getData(names[i]);
			}
			val = (Boolean) uiData.getData(names[names.length - 1]);
		} else {
			val = (Boolean) uiData.getData(dataName);
		}
		if (val == null) {
			this.setText("");
		} else {
			if (val) {
				setText(ClientResourceBundle.getString(trueLabelKey));
			} else {
				setText(ClientResourceBundle.getString(falseLabelKey));
			}
		}
	}

	private String displayKey;

	public void getData(UiData uiData, UiErrors errors, String errorPrefix) {
		String text = this.getText();
		uiData.setData(dataName, text);
	}

	private String dataName;

	public String getDataName() {
		return dataName;
	}

	public void setDataName(String dataName) {
		this.dataName = dataName;
	}

	public void clearData() {
		setText("");
	}

	private boolean ignore = false;

	public boolean getIgnore() {
		return ignore;
	}

	public void setIgnore(boolean ignore) {
		this.ignore = ignore;
	}

	public void setDisplayKey(String displayKey) {
		this.displayKey = displayKey;
	}

	public String getDisplayKey() {
		return displayKey;
	}

	public void setTrueLabelKey(String trueLabelKey) {
		this.trueLabelKey = trueLabelKey;
	}

	public String getTrueLabelKey() {
		return trueLabelKey;
	}

	public void setFalseLabelKey(String falseLabelKey) {
		this.falseLabelKey = falseLabelKey;
	}

	public String getFalseLabelKey() {
		return falseLabelKey;
	}

}
