package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.Label;
import com.gwtorbit.client.model.UiData;
import com.gwtorbit.client.model.UiDataDisplay;
import com.gwtorbit.client.model.UiErrors;
import com.gwtorbit.client.mvp.ClientResourceBundle;

public class UiLabelFileSize extends Label implements UiDataDisplay {

	public void displayData(UiData uiData) {
		Number number = null;
		if (dataName.indexOf(".") > -1) {
			String[] names = dataName.split("\\.");
			for (int i = 0; i < (names.length - 1); i++) {
				uiData = (UiData) uiData.getData(names[i]);
			}
			number = (Number) uiData.getData(names[names.length - 1]);
		} else {
			number = (Number) uiData.getData(dataName);
		}
		if (number == null) {
			this.setText("");
		} else {
			String sizeAsString = "";

			long size = number.longValue();
			if (size < 1024) { // less than 1KB
				sizeAsString = ClientResourceBundle.getString("page.label.fileSizeKB", "1");
			} else if (size < 1048576) { // less than 1MB
				size = (size + 1023) / 1024;
				sizeAsString = ClientResourceBundle.getString("page.label.fileSizeKB",
						ClientResourceBundle.integerFormat.format(size));
			} else { // 1MB and over
				size = (size + 1048575) / 1048576;
				sizeAsString = ClientResourceBundle.getString("page.label.fileSizeMB",
						ClientResourceBundle.integerFormat.format(size));
			}

			if (displayKey == null) {
				this.setText(sizeAsString);
			} else {
				this.setText(ClientResourceBundle.getString(displayKey, sizeAsString));
			}
		}
	}

	private String displayKey;

	public void getData(UiData uiData, UiErrors errors, String errorPrefix) {
		String text = this.getText();
		uiData.setData(dataName, text);
	}

	private String dataName;

	public String getDataName() {
		return dataName;
	}

	public void setDataName(String dataName) {
		this.dataName = dataName;
	}

	public void clearData() {
		setText("");
	}

	private boolean ignore = false;

	public boolean getIgnore() {
		return ignore;
	}

	public void setIgnore(boolean ignore) {
		this.ignore = ignore;
	}

	public void setDisplayKey(String displayKey) {
		this.displayKey = displayKey;
	}

	public String getDisplayKey() {
		return displayKey;
	}

}
